<ol class="breadcrumb">
  <li><a href="/">Home</a></li>
  <li><a href="/book/">Book</a></li>
  <li class="active">PART ONE: Grokking Lisp</li>
</ol>

# PART ONE: Grokking Lisp

> "'Grok' means to understand so thoroughly that the observer becomes a part of the process being observed—to merge, to blend, to intermarry, to lose personal identity in group experience. It means almost everything that we mean by religion, philosophy, and science—and it means as little to us as color means to a blind man."
> <footer>Robert A. Heinlein, <em>Stranger in a Strange Land</em></footer>

Lisp isn't a language you just *learn*.  It changes you, as a programmer and a person.

In Part One, we focus on the core of the Common Lisp language, features that you will use every day, and techniques that will change the way you see programming.

We'll start with a high-level overview of the whole language, working through the details of syntax, semantics, style, and configuration of your development environment.

From there we'll move on to strings, characters, writing, and printing; prompting for user input; lists, trees, and special lists like alists and plists; math, vectors and arrays; lexical scope and variables; and functions.

Then we'll build our first application, a straight-forward text-adventure, using everything you've learned up to that point.

<ul class="pager">
  <li class="previous"><a href="/book/acknowledgements/">&laquo; Previous</a></li>
  <li><a href="/book/">Table of Contents</a></li>
  <li class="next"><a href="/book/1-01-00-lisp-bootcamp/">Next &raquo;</a><li>
</ul>
