<ol class="breadcrumb">
  <li><a href="/">Home</a></li>
  <li><a href="/book/">Book</a></li>
  <li class="active">Preface :: The Hard Way Is Easier</li>
</ol>

# The Hard Way Is Easier

> "Do not handicap your children by making their lives easy."
> <footer>Robert A. Heinlein, <em>Time Enough for Love</em></footer>

Whatever you think you know about programming, forget it.  Lisp is different from other programming languages.

If you're coming to Lisp as an experienced developer, it is only fair to tell you upfront that your experience will hold you back.  It will make you feel bored when the material isn't "challenging you".  It will make you skip over sections you think you already understand.  It will tell you reading the code examples once is enough to learn it, that it's okay to copy-and-paste.  But none of this is true---and if you slack off now, you'll only be making things harder for yourself later.

No matter who you are or what your background is, if you stick to the steps of learning the hard way, you'll see that it is actually easier in the long run.  You'll have to work hard, but you'll learn what you need to learn the first time, and you won't forget it.

Learning the hard way means following these five steps every day until you've completed this book:

1. Forget everything you know
2. Work through each exercise from beginning to end
3. Type in each example *exactly*
4. Make the code run
5. Reflect on what you've seen

And that is all.

Depending on your level of self-discipline, you may have a more difficult time sticking to these steps than some---but this isn't a contest.  Don't worry about how long it takes you to work through an exercise, don't panic if you have to miss a day, and don't compare yourself to others.  If you do your best to apply these steps every day, you will develop the self-discipline required to see this book through to the end.

An important theme of this book is also on the skills necessary for programming in general, while using Lisp to reinforce them.  These skills are: reading and writing, mathematics, attention to detail, and spotting differences.  Thus, once you finish this book, you won't just be a Lisp Hacker, you'll be ready to tackle other programming languages too---and in the process you might just discover that learning a new skill is more fun than any hobby, game, movie, or tv show.

### Reading and Writing

Programming, much like human language, involves the intentional use of a specific set of language-dependent characters, some of which you might not be used to typing. If you have trouble reading, writing, or typing, you will struggle writing code.

Take the time to read over the code examples carefully, and double-check your work once you have typed it.  This will save you a lot of migraines along the way.

### Attention to Detail

More than any other skill, what separates a professional from an amateur in every field and trade is attention to detail.  In programming, this is especially obvious; it makes the difference between mayhem and a bug-free, user-friendly, indispensable tool.

By manually typing each exercise *exactly* as you work through this book, you will be training your brain to focus on the subtle details of what you are doing, while you are doing it.

### Spotting Differences

The natural extension to the first two skills is the ability to spot differences.  With careful reading, typing, and attention to detail, you will also be training your brain to highlight subtle differences, so that when you make a mistake, you notice.

Naturally, this skill will also help you more quickly spot and correct bugs in other people's code that you have to upgrade and maintain.

### Mathematics

Remember in high school, there was always at least one classmate that would demand to know when, in life, any of you would ever need to know half the stuff they taught you?  You may have even been that student.  Well, you may be disappointed to know that programmers need to use nearly the entire high school and university level math curricula every day.  You don't have to be a math-whiz to be a programmer, but at the end of the day, programming is still mostly math.

If you were never very good at math, however, don't panic.  This book and its exercises assumes little to no familiarity with mathematics, so you can learn both math and programming at the same time if you need to.

### No Copy-and-Paste

If you copy-and-paste the code from the exercises into the Lisp REPL instead of typing them out yourself, you might as well not do them at all.  As both teacher and student for the duration of this book, you have to force yourself to type in every example.  No matter how easy or self-evident a code example appears to be, you have to stop yourself.

The point of these exercises is to train your hands, your eyes, your brain, and your mind how to read, write, see, think, and dream code.  When you cheat here, you're cheating yourself.

<ul class="pager">
  <li class="previous"><a href="/book/preface/">&laquo; Previous</a></li>
  <li><a href="/book/">Table of Contents</a></li>
  <li class="next"><a href="/book/preface-part-three/">Next &raquo;</a><li>
</ul>
